﻿using System;
using System.Threading;

// Dette program illustrerer synkronisering af tråde vha resource-monitor

namespace Trådeksempel10_TrådOgResourceMonitor
{
    class Program
    {
        static void Main(string[] args)
        {
            TaellerMonitor taellerMonitor;
            taellerMonitor = new TaellerMonitor();		// skab resource-monitor

            TrådNedtæl trådNed = new TrådNedtæl(taellerMonitor);
            TrådOptæl trådOp = new TrådOptæl(taellerMonitor);
            TrådVis trådVis = new TrådVis(taellerMonitor);

            Thread optaelTraad, nedtaelTraad, visTraad;
            // Skab tråde
            optaelTraad = new Thread(trådOp.Optael);
            nedtaelTraad = new Thread(trådNed.Nedtael);
            visTraad = new Thread(trådVis.Vis);

            Console.WriteLine("Tast retur for at starte og igen for at stoppe");
            Console.ReadLine();

            optaelTraad.Start();	// Start tråd, som hele tiden tæller én op
            nedtaelTraad.Start();	// Start tråd, som hele tiden tæller én ned
            visTraad.Start();		// Start tråd, som hele tiden viser tæller-værdi

            Console.ReadLine();
            trådOp.SignalStop();
            trådNed.SignalStop();
            trådVis.SignalStop();

            optaelTraad.Join();
            nedtaelTraad.Join();
            visTraad.Join();

        }
    }
}
