﻿using System;
using System.Threading;

namespace Trådeksempel10_TrådOgResourceMonitor
{
    // Monitor-klasse. Klassen er thread-safe
    public class TaellerMonitor
    {
        private int taeller;			// fælles data i monitor

        // Konstruktør som nulstiller tæller
        public TaellerMonitor()
        {
            taeller = 0;
        }

        // Metoden er synkroniseret
        public void Optael()
        {
            lock (this)				// tag objekt-lås (synkroniser)
            {
                taeller++;
            }

            // Alternativt:
            //Interlocked.Increment(ref taeller);
        }

        // Metoden er synkroniseret
        public void Nedtael()
        {
            lock (this)
            {
                taeller--;			// tag objekt-lås (synkroniser)
            }

            // Alternativt:
            //Interlocked.Decrement(ref taeller);
        }

        public int GetTaeller()
        {
            int tallerValue;
            lock (this)
            {
                tallerValue = taeller;			// tag objekt-lås (synkroniser)
            }
            return tallerValue;			// synkronisering er ikke nødvendig, når tæller kun læses og er simpel type, der hentes i en maskin-instruktion
        }
    }
}
